PROGRAM WEEKTOP;

USES Radu,Dos;

TYPE  Time           = String[5];
      Date           = String[8];
      VideoType      = (Auto, Short, Long);
      AskType        = (Yes, No, Ask, Only);
      MSGTOIDXrecord = String[35];
      FlagType       = array[1..4] of Byte;
      COMBINEDrecord = array[1..200] of Word;

      ARCrecord = record
                Extension : String[3];
                UnpackCmd,
                PackCmd   : String[60];
              end;

      NetAddress     = record
                     Zone,
                     Net,
                     Node,
                     Point          : Word;
                   end;

      weektoprecord=RECORD
                   handle:msgtoidxrecord;
                   location:string[25];
                   load:array[1..2] of longint;
                   END;

     USERSrecord    = record
                     Name           : MSGTOIDXrecord;
                     Location       : String[25];
                     Organisation,
                     Address1,
                     Address2,
                     Address3       : String[50];
                     Handle         : String[35];
                     Comment        : String[80];
                     PasswordCRC    : LongInt;
                     DataPhone,
                     VoicePhone     : String[15];
                     LastTime       : Time;
                     LastDate       : Date;
                     Attribute,
                     Attribute2     : Byte;
                     Flags          : FlagType;
                     Credit,
                     Pending        : LongInt;
                     MsgsPosted,
                     Security       : Word;
                     LastRead,
                     NoCalls,
                     Uploads,
                     Downloads,
                     UploadsK,
                     DownloadsK,
                     TodayK         : LongInt;
                     Elapsed        : Integer;
                     ScreenLength   : Word;
                     LastPwdChange  : Byte;
                     Group          : Word;
                     CombinedInfo   : COMBINEDrecord;
                     FirstDate,
                     BirthDate,
                     SubDate        : Date;
                     ScreenWidth,
                     Language,
                     DateFormat     : Byte;
                     ForwardTo      : String[35];
                     MsgArea,
                     FileArea       : Word;
                     DefaultProtocol: Char;
                     FileGroup      : Word;
                     LastDOBCheck   : Byte;
                     Sex            : Byte;
                     XIrecord       : LongInt;
                     MsgGroup       : Word;
                     Attribute3     : Byte;
                     Password       : String[15];
                     FreeSpace      : Array[1..31] of Byte;
                   end;

  CONFIGrecord = record
    VersionID           : Word;
    xCommPort           : Byte;
    xBaud               : LongInt;
    xInitTries          : Byte;
    xInitStr,
    xBusyStr            : String[70];
    xInitResp,
    xBusyResp,
    xConnect300,
    xConnect1200,
    xConnect2400,
    xConnect4800,
    xConnect9600,
    xConnect19k,
    xConnect38k         : String[40];
    xAnswerPhone        : Boolean;
    xRing,
    xAnswerStr          : String[20];
    xFlushBuffer        : Boolean;
    xModemDelay         : Integer;

    MinimumBaud,
    GraphicsBaud,
    TransferBaud        : word;
    SlowBaudTimeStart,
    SlowBaudTimeEnd,
    DownloadTimeStart,
    DownloadTimeEnd     : Time;

    PageStart           : Array[0..6] of Time;
    PageEnd             : Array[0..6] of Time;

    SeriNum,
    CustNum             : String[22];
{}  FreeSpace1          : Array[1..24] of Byte;
    PwdExpiry           : Word;

    MenuPath,
    TextPath,
    AttachPath,
    NodelistPath,
    MsgBasePath,
    SysPath,
    ExternalEdCmd       : String[60];

    Address             : Array[0..9] of NetAddress;
    SystemName          : String[30];

    NewSecurity         : Word;
    NewCredit           : Word;
    NewFlags            : FlagType;

    OriginLine          : String[60];
    QuoteString         : String[15];
    Sysop               : String[35];
    LogFileName         : String[60];
    FastLogon,
    AllowSysRem,
    MonoMode,
    StrictPwdChecking,
    DirectWrite,
    SnowCheck           : Boolean;
    CreditFactor        : Integer;

    UserTimeOut,
    LogonTime,
    PasswordTries,
    MaxPage,
    PageLength          : Word;
    CheckForMultiLogon,
    ExcludeSysopFromList,
    OneWordNames        : Boolean;
    CheckMail           : AskType;
    AskVoicePhone,
    AskDataPhone,
    DoFullMailCheck,
    AllowFileShells,
    FixUploadDates,
    FreezeChat          : Boolean;
    ANSI,                       { ANSI: Yes, no, or ask new users     }
    ClearScreen,                { Clear:        "                     }
    MorePrompt          : AskType;    { More:         "                     }
    UploadMsgs          : Boolean;
    KillSent            : AskType;    { Kill/Sent     "                     }

    CrashAskSec         : Word;       { Min sec# to ask 'Crash Mail ?'      }
    CrashAskFlags       : FlagType;
    CrashSec            : Word;       { Min sec# to always send crash mail. }
    CrashFlags          : FlagType;
    FAttachSec          : Word;       {        "    ask 'File Attach ?'     }
    FAttachFlags        : FlagType;

    NormFore,
    NormBack,
    StatFore,
    StatBack,
    HiBack,
    HiFore,
    WindFore,
    WindBack,
    ExitLocal,
    Exit300,
    Exit1200,
    Exit2400,
    Exit4800,
    Exit9600,
    Exit19k,
    Exit38k             : Byte;

    MultiLine           : Boolean;
    MinPwdLen           : Byte;
    MinUpSpace          : Word;
    HotKeys             : AskType;
    BorderFore,
    BorderBack,
    BarFore,
    BarBack,
    LogStyle,
    MultiTasker,
    PwdBoard            : Byte;
    xBufferSize         : Word;
    FKeys               : Array[1..10] of String[60];

    WhyPage             : Boolean;
    LeaveMsg            : Byte;
    ShowMissingFiles,
    xLockModem          : Boolean;
{}  FreeSpace2          : Array[1..10] of Byte;
    AllowNetmailReplies : Boolean;
    LogonPrompt         : String[40];
    CheckNewFiles       : AskType;
    ReplyHeader         : String[60];
    BlankSecs           : byte;
    ProtocolAttrib      : Array[1..6] of Byte;
    xErrorFreeString    : String[15];
    xDefaultCombined    : array[1..25] of Byte;
    RenumThreshold      : Word;
    LeftBracket,
    RightBracket        : Char;
    AskForHandle        : Boolean;
    AskForBirthDate     : Boolean;

    GroupMailSec        : Word;

    ConfirmMsgDeletes   : Boolean;

    FreeSpace4          : Array[1..30] of byte;

    TempScanDir         : String[60];
    ScanNow             : AskType;
    xUnknownArcAction,
    xFailedUnpackAction,
    FailedScanAction    : Byte; {Bit 0:Mark deleted, 1:Mark unlisted, 2:Mark notavail}
    xUnknownArcArea,
    xFailedUnpackArea,
    FailedScanArea      : Word;
    ScanCmd             : String[60];
    xDeductIfUnknown    : Boolean;

    NewUserGroup        : Byte;
    AVATAR              : AskType;
    BadPwdArea          : Byte;
    Location            : String[40];
    DoAfterAction       : Byte; {0 = wait for CR, > 0 = wait for x seconds}
{}  OldFileLine         : String[40];
    CRfore,
    CRback              : Byte;
    LangHdr             : String[40];
    xSendBreak          : Boolean;
{}  ListPath            : String[60];
    FullMsgView         : AskType;
    EMSI_Enable         : AskType;
    EMSI_NewUser        : Boolean;

    EchoChar            : String[1];
    xConnect7200,
    xConnect12000,
    xConnect14400       : String[40];
    Exit7200,
    Exit12000,
    Exit14400           : Byte;
    ChatCommand         : String[60];
    ExtEd               : AskType;
    NewuserLanguage     : Byte;
    LanguagePrompt      : String[40];
    VideoMode           : VideoType;
    AutoDetectANSI      : Boolean;
    xOffHook            : Boolean;
    NewUserDateFormat   : Byte;
    KeyboardPwd         : String[15];
    CapLocation         : Boolean;
    NewuserSub          : Byte;
    PrinterName         : String[4];
    HilitePromptFore,
    HiLitePromptBack    : Byte;
    xInitStr2           : String[70];
    AltJSwap            : Boolean;
    SemPath             : String[60];
    AutoChatCapture     : Boolean;

    FileBasePath        : String[60];
    NewFileTag          : Boolean;
    IgnoreDupeExt       : Boolean;
    TempCDFilePath      : String[60];
    TagFore,
    TagBack             : Byte;
    xConnect16k         : String[40];
    Exit16k,
    FilePayback         : Byte;
    FileLine,
    FileMissingLine     : String[200];
    NewUserULCredit     : Byte;
    NewUserULCreditK    : Word;
    ArcInfo             : Array[1..10] of ARCrecord;
    RAMGRAltFKeys       : Array[1..5] of String[60];
    ArcViewCmd          : String[60];
    xConnectFax         : String[40];
    ExitFax             : Byte;
    UseXMS,
    UseEMS              : Boolean;
    CheckDOB            : Byte;
    EchoCheck           : AskType;
    ccSec,
    ReturnRecSec        : Word;
    HonourNetReq        : Boolean;
    DefaultCombined     : COMBINEDrecord;
    AskForSex,
    AskForAddress       : Boolean;
    DLdesc              : AskType;
    NewPhoneScan        : Boolean;

    Exit21k,
    Exit24k,
    Exit26k,
    Exit28k,
    Exit57k,
    Exit64k             : Byte;

    TagLogoffWarning,
    LimitLocal,
    SavePasswords       : Boolean;

    BlankLogins         : Byte;
    ripiconpath         : string[60];

    Exit31k,
    Exit33k             : Byte;
    IncludeNewCDareas   : Boolean;

    FutureExpansion : Array[1..513] of Byte;
  end;

procedure Upper4(var Str: String);
  InLine(
    $8C/$DA/               {      mov   DX,DS               }
    $5E/                   {      pop   SI                  }
    $1F/                   {      pop   DS                  }
    $FC/                   {      cld                       }
    $AC/                   {      lodsb                     }
    $30/$E4/               {      xor   AH,AH               }
    $89/$C1/               {      mov   CX,AX               }
    $E3/$12/               {      jcxz  @30                 }
    $BB/Ord('a')/Ord('z')/ {      mov   BX,'za'             }
    $AC/                   { @15: lodsb                     }
    $38/$D8/               {      cmp   AL,BL               }
    $72/$08/               {      jb    @28                 }
    $38/$F8/               {      cmp   AL,BH               }
    $77/$04/               {      ja    @28                 }
    $80/$6C/$FF/$20/       {      sub   BYTE PTR [SI-1],$20 }
    $E2/$F1/               { @28: loop  @15                 }
    $8E/$DA);              { @30: mov   DS,DX               }

FUNCTION PADL( s: STRING; n: BYTE; c: CHAR ): STRING; ASSEMBLER;
ASM
      PUSH   DS
      CLD

      LES    DI, @Result
      INC    DI
      LDS    SI, s
      XOR    AX, AX
      LODSB
      PUSH   AX

      XOR    CX, CX
      MOV    CL, n
      SUB    CL, AL

      CMP    CX, 0
      JNB    @@1
      XOR    CX, CX

@@1:  MOV    AL, c
      REP    STOSB

      POP    CX
      REP    MOVSB

      MOV    DI, WORD PTR @Result
      MOV    AL, n
      MOV    BYTE PTR ES:[DI], AL
      POP    DS
END;

FUNCTION FileExists(FileName : String) : Boolean; ASSEMBLER;
ASM
  PUSH DS          {Save DS                         }
  LDS  SI,Filename {DS:SI => Filename               }
  XOR  BX,BX       {Clear BX                        }
  MOV  BL,[SI]     {BX = Length(Filename)           }
  INC  SI          {DS:SI => Filename[1]            }
  MOV  DX,SI       {DS:DX => Filename[1]            }
  MOV  [SI+BX],BH  {Append Ascii 0 to Filename      }
  MOV  AX,4300h    {Get Attribute Function Code     }
  INT  21h         {Get File Attributes             }
  MOV  AL,BH       {Default Result = FALSE          }
  ADC  CL,CL       {Attribute * 2 + Carry Flag      }
  AND  CL,31h      {Directory or VolumeID or Failed }
  JNZ  @@Done      {Yes - Exit                      }
  INC  AL          {No - Change Result to TRUE      }
@@Done:
  POP  DS          {Restore DS                      }
END; {FileExists}


FUNCTION lpath:string;

  VAR path2ra,path:string;

  BEGIN
  path2ra:=paramstr(0);
  repeat
  delete(path2ra,1,(pos('\',path2ra)));
  until pos('\',path2ra)=0;
  path:=paramstr(0);
  delete(path,pos(path2ra,paramstr(0)),20);
  lpath:=path;
  END;

FUNCTION msgbasepath:string;

  VAR f:file of configrecord;
      config:configrecord;

  BEGIN
  assign(f,getenv('RA')+'\config.ra');
  filemode:=0;
  {$I-}
  reset(f);
  {$I+}
  if ioresult<>0 then
     BEGIN
     writeln(' ! ERROR READING CONFIG.RA');
     halt(1);
     END;
  {$I-}
  read(f,config);
  {$I+}
  if ioresult<>0 then
     BEGIN
     writeln(' ! ERROR READING CONFIG.RA');
     halt(1);
     END;
  close(f);
  msgbasepath:=config.msgbasepath;
  END;

VAR wtr:array[1..11] of weektoprecord;
    wh,wta,a,load1,load2:integer;
    all:longint;
    percent:real;
    st:string;
    key:char;
    prompt:array[1..20] of string[80];
    prompta:byte;

PROCEDURE readprompt;

VAR p:text;
    str:string;
    index:integer;

BEGIN
assign(p,dorpath+'weektop.ptm');
filemode:=0;
{$I-}
reset(p);
{$I+}
if ioresult<>0 then
   BEGIN
   ralog('ERROR READING PROMPT. HALTED');
   halt(1);
   END;
readln(p,str);
val(str,prompta,index);
if index<>0 then
   BEGIN
   halt(1);
   END;
for index:=1 to prompta do
    BEGIN
    readln(p,prompt[index]);
    END;
close(p);
END;

PROCEDURE createnew;

VAR w:file of weektoprecord;
    u:file of usersrecord;
    wt:weektoprecord;
    user:usersrecord;
    a:byte;

BEGIN
textcolor(lightgray);
writeln(' WEEKTOP                                                        by POTi^XPRESS');
writeln('[]');
writeln(' # opening weektop.idx');
assign(w,lpath+'weektop.idx');
{$I-}
rewrite(w);
{$I+}
if ioresult<>0 then
   BEGIN
   writeln(' ! ERROR WRITING WEEKTOP.IDX');
   halT(1);
   END;
writeln(' # opening users.bbs');
assign(u,msgbasepath+'users.bbs');
{$I-}
reset(u);
{$I+}
if ioresult<>0 then
   BEGIN
   writeln(' ! ERROR READING USERS.BBS');
   halT(1);
   END;
writeln(' # working');
repeat
{$I-}
read(u,user);
{$I+}
if ioresult<>0 then
   BEGIN
   writeln(' ! ERROR READING USERS.BBS. HALTED');
   halt(1);
   END;
wt.handle:=user.handle;
wt.load[1]:=user.downloadsk;
wt.load[2]:=user.uploadsk;
wt.location:=user.location;
write(w,wt);
until eof(u);
close(w);
writeln(' # closing weektop.idx');
close(u);
writeln(' # closing users.bbs');
END;

PROCEDURE readinup(what:byte);

VAR w:file of weektoprecord;
    u:file of usersrecord;
    wt:weektoprecord;
    user:usersrecord;
    i:integer;
    a:integer;
    large:integer;

BEGIN
all:=0;
wta:=0;
filemode:=0;
assign(w,lpath+'weektop.idx');
{$I-}
reset(w);
{$I+}
if ioresult<>0 then
   BEGIN
   ralog('ERROR READING WEEKTOP.IDX');
   halt(1);
   END;
assign(u,msgbasepath+'users.bbs');
{$I-}
reset(u);
{$I+}
if ioresult<>0 then
   BEGIN
   ralog('ERROR READING USERS.BBS');
   halt(1);
   END;
repeat
{$I-}
read(u,user);
{$I+}
if ioresult<>0 then
   BEGIN
   ralog('ERROR READING USERS.BBS');
   halt(1);
   END;
{$I-}
read(w,wt);
{$I+}
if ioresult<>0 then
   BEGIN
   ralog('ERROR READING WEEKTOP.IDX');
   halt(1);
   END;
if (what=2) and (user.uploadsk > wt.load[what]) then
   BEGIN
   wta:=wta+1;
   wtr[wta]:=wt;
   wtr[wta].load[1]:=user.downloadsk-wt.load[1];
   wtr[wta].load[2]:=user.uploadsk-wt.load[2];
   all:=all+wtr[wta].load[2];
   END;
if (what=1) and (user.downloadsk > wt.load[what]) then
   BEGIN
   wta:=wta+1;
   wtr[wta]:=wt;
   wtr[wta].load[1]:=user.downloadsk-wt.load[1];
   wtr[wta].load[2]:=user.uploadsk-wt.load[2];
   all:=all+wtr[wta].load[1];
   END;
if wta>1 then
   BEGIN
   for i:=1 to (wta-1) do
    BEGIN
    large:=i;
    for a:=(i+1) to wta do
        BEGIN
        if wtr[a].load[what]>wtr[large].load[what] then
           BEGIN
           large:=a;
           END;
        END;
    if large<>i then
       BEGIN
       wt:=wtr[large];
       wtr[large]:=wtr[i];
       wtr[i]:=wt;
       END;
    END;
   END;
if wta>10 then wta:=10;
until eof(u);
close(w);
close(u);
writeln(wta);
END;

PROCEDURE fadein(a:integer);

VAR x:byte;

BEGIN
for x:=1 to 3 do
    BEGIN
    if x=1 then textcolor(darkgray);
    if x=2 then textcolor(lightgray);
    if x=3 then textcolor(lightcyan);
    gotoxy(7,(9+a));
    write(copy(wtr[a].handle,1,22));
    gotoxy(31,(9+a));
    write(copy(wtr[a].location,1,21));
    gotoxy(54,(9+a));
    load1:=wtr[a].load[wh] div 1000;
    load2:=wtr[a].load[wh] mod 1000;
    str(load1,st);
    write(padl(st,5,' '),',');
    str(load2,st);
    gotoxy(60,(9+a));
    write(padl(st,3,'0'));
    percent:=wtr[a].load[wh]*100/all;
    gotoxy(68,(9+a));
    write(percent:3:1);
    delay(30);
    END;
END;

VAR index:byte;
    ende:boolean;

BEGIN
st:=paramstr(1);
upper4(st);
if (fileexists(lpath+'weektop.idx')=false) or (pos('B',st)<>0) then
   BEGIN
   createnew;
   halT(10);
   END;
rc:='434552355325342';
dorinit;
ralog('WEEKTOP 1.0 BY POTi^XPRESS FOR RAT');
readprompt;
for wh:=2 downto 1 do
BEGIN
readinup(wh);
if wh=2 then dordisplay(dorpath+'weektopu.ans','',false) else
   dordisplay(dorpath+'weektopd.ans','',false);
for a:=1 to wta do
    BEGIN
    fadein(a);
    END;
gotoxy(58,21);
load1:=all div 1000;
str(load1,st);
write(padl(st,5,' '));
index:=0;
ende:=false;
repeat
index:=index+1;
if index=prompta then index:=0;
gotoxy(1,23);
write(prompt[index]);
delay(100);
if keypressed then
   BEGIN
   key:=readkey;
   if ord(key)=13 then ende:=true;
   END;
until ende;
END;
END.